"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.babelProjectPlugin = void 0;

var _tapable = require("tapable");

var _plugins = require("@sewing-kit/plugins");

const PLUGIN = 'SewingKit.babel';
const addBabelHooks = (0, _plugins.addHooks)(() => ({
  babelConfig: new _tapable.AsyncSeriesWaterfallHook(['babelConfig']),
  babelIgnorePatterns: new _tapable.AsyncSeriesWaterfallHook(['babelIgnorePatterns'])
}));
const babelProjectPlugin = (0, _plugins.createProjectPlugin)({
  id: PLUGIN,

  run({
    build,
    test
  }) {
    build.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.package.tap(PLUGIN, ({
        hooks
      }) => {
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
      hooks.webApp.tap(PLUGIN, ({
        hooks
      }) => {
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
      hooks.service.tap(PLUGIN, ({
        hooks
      }) => {
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
    });
    test.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.project.tap(PLUGIN, ({
        hooks
      }) => {
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
    });
  }

});
exports.babelProjectPlugin = babelProjectPlugin;