function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { resolve } from 'path';
import { rename } from 'fs-extra';
import { sync as glob } from 'glob';
import { createStep } from '@sewing-kit/ui';
import { toArgs, MissingPluginError } from '@sewing-kit/plugins';
export function createCompileBabelStep(pkg, api, config, options) {
  return createStep(function _callee(step) {
    var _options$configFile, configFile, outputPath, extension, babelConfigPath, _ref, _ref2, babelConfig, babelIgnorePatterns, extensions, sourceRoot, replaceJsWith;

    return regeneratorRuntime.async(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _options$configFile = options.configFile, configFile = _options$configFile === void 0 ? 'babel.js' : _options$configFile, outputPath = options.outputPath, extension = options.extension;
            babelConfigPath = api.configPath("build/packages/".concat(pkg.name, "/").concat(configFile));

            if (!(config.babelConfig == null || config.babelIgnorePatterns == null)) {
              _context.next = 4;
              break;
            }

            throw new MissingPluginError('@sewing-kit/plugin-babel');

          case 4:
            _context.next = 6;
            return regeneratorRuntime.awrap(Promise.all([config.babelConfig.promise({}), config.babelIgnorePatterns.promise([])]));

          case 6:
            _ref = _context.sent;
            _ref2 = _slicedToArray(_ref, 2);
            babelConfig = _ref2[0];
            babelIgnorePatterns = _ref2[1];
            _context.next = 12;
            return regeneratorRuntime.awrap(api.write(babelConfigPath, "module.exports=".concat(JSON.stringify(babelConfig), ";")));

          case 12:
            _context.next = 14;
            return regeneratorRuntime.awrap(config.extensions.promise([]));

          case 14:
            extensions = _context.sent;
            sourceRoot = resolve(pkg.root, 'src');
            _context.next = 18;
            return regeneratorRuntime.awrap(step.exec('node_modules/.bin/babel', [sourceRoot].concat(_toConsumableArray(toArgs({
              outDir: outputPath,
              configFile: babelConfigPath,
              verbose: true,
              noBabelrc: true,
              babelConfig: false,
              extensions: extensions.join(','),
              ignore: babelIgnorePatterns.length > 0 ? babelIgnorePatterns.join(',') : undefined
            }, {
              dasherize: true
            })))));

          case 18:
            if (!extension) {
              _context.next = 22;
              break;
            }

            replaceJsWith = extension.startsWith('.') ? extension : ".".concat(extension);
            _context.next = 22;
            return regeneratorRuntime.awrap(Promise.all(glob('**/*.js', {
              cwd: outputPath,
              absolute: true
            }).map(function (file) {
              return rename(file, file.replace(/\.js$/, replaceJsWith));
            })));

          case 22:
          case "end":
            return _context.stop();
        }
      }
    });
  });
}