import { AsyncSeriesWaterfallHook } from 'tapable';
import { addHooks, createProjectPlugin } from '@sewing-kit/plugins';
const PLUGIN = 'SewingKit.babel';
const addBabelHooks = addHooks(() => ({
  babelConfig: new AsyncSeriesWaterfallHook(['babelConfig']),
  babelIgnorePatterns: new AsyncSeriesWaterfallHook(['babelIgnorePatterns'])
}));
export const babelProjectPlugin = createProjectPlugin({
  id: PLUGIN,

  run({
    build,
    test
  }) {
    build.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.package.tap(PLUGIN, ({
        hooks
      }) => {
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
      hooks.webApp.tap(PLUGIN, ({
        hooks
      }) => {
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
      hooks.service.tap(PLUGIN, ({
        hooks
      }) => {
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
    });
    test.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.project.tap(PLUGIN, ({
        hooks
      }) => {
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
    });
  }

});